﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GridGroupBySlowExample {
  public partial class Form1 : Form {
    private readonly BindingList<Foo> Items = new BindingList<Foo>();

    public Form1() {
      InitializeComponent();
    }

    private void DoPerformanceTest() {
      FillItems();

      var sw = new Stopwatch();
      sw.Start();

      // Just getting the enumerator on Rows is slow
      foreach (var row in ultraGrid1.Rows) {
        // do something
      }

      sw.Stop();
      ultraLabel1.Text = sw.ElapsedMilliseconds.ToString();
    }

    private void FillItems() {
      Items.Clear();
      for (var i = 0; i < 10000; i++)
        Items.Add(new Foo(i.ToString(), GetGroup(i)));
    }

    private string GetGroup(int i) {
      var c1 = (char)(65 + ((i / 26) % 15));
      var c2 = (char)(65 + (i % 26));

      return c1.ToString() + c2.ToString();
    }

    private void Form1_Load(object sender, EventArgs e) {
      ultraGrid1.DataSource = Items;
      ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add("Group", false, true);
      FillItems();
    }

    private void ultraButton1_Click(object sender, EventArgs e) {
      DoPerformanceTest();
    }

  }

  internal class Foo {
    public Foo(string name, string group) {
      Name = name;
      Group = group;
    }

    public string Name { get; set; }
    public string Group { get; set; }
  }
}
